#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 50;

void inputAndBuildArrays(const int n, int32_t* a, int32_t* nextStrictlyBigger, int32_t* nextNotStrictlyBigger)
{
    stack <int32_t> tempStrictly, tempNotStrictly;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];

        while (!tempStrictly.empty() && a[tempStrictly.top()] < a[i])
        {
            nextStrictlyBigger[tempStrictly.top()] = i;
            tempStrictly.pop();
        }

        while (!tempNotStrictly.empty() && a[tempNotStrictly.top()] <= a[i])
        {
            nextNotStrictlyBigger[tempNotStrictly.top()] = i;
            tempNotStrictly.pop();
        }
        tempNotStrictly.push(i);
        tempStrictly.push(i);
    }

    while (!tempNotStrictly.empty())
    {
        nextNotStrictlyBigger[tempNotStrictly.top()] = n;
        tempNotStrictly.pop();
    }
    while (!tempStrictly.empty())
    {
        nextStrictlyBigger[tempStrictly.top()] = n;
        tempStrictly.pop();
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    int32_t a[MAXN] = {0};
    int32_t nextStrictlyBigger[MAXN] = {0};
    int32_t nextNotStrictlyBigger[MAXN] = {0};
    int32_t dp[MAXN] = {0};
    stack <int32_t> tempNotStrictly, tempStrictly;

    cin >> n;
    inputAndBuildArrays(n, a, nextStrictlyBigger, nextNotStrictlyBigger);

    dp[n] = -1;
    for (int i = n-1; i >= 0; i--)
        dp[i] = dp[nextNotStrictlyBigger[i]]+1;

    for (int i = 0; i < n; i++)
    {
        cout << i << " -> " << dp[i] << endl;
    }

    return 0;
}
