#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int MAXN = 1e5 + 10, MOD = 998244353;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, a[MAXN];

void read()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
        cin >> a[i];
}

int dp[MAXN];
int t[MAXN * 4];

int query(int i, int l, int r, int ql, int qr)
{
   // cout << i << " " << l << " " << r << endl;
    //if(i < 1)return 0;
    if(l == ql && qr == r)return t[i]%MOD;
    int mid = (l + r)/2;
    if(qr <= mid)return query(2*i, l, mid, ql, qr);
    else if(ql > mid)return query (2*i+1, mid+1, r, ql, qr);
    else return (query(2*i, l, mid, ql, mid) + query(2*i+1, mid+1, r, mid+1, qr) % MOD);
}

void update(int i, int l, int r, int idx, int val)
{
    //cout << i << endl;
    if(l == r)
    {
        t[i] += val;
        t[i] %= MOD;
        return;
    }
    int mid = (l + r)/2;
    if(idx <= mid)update(2*i, l, mid, idx, val);
    else update(2*i+1, mid+1, r, idx, val);
    t[i] = (t[2*i] + t[2*i+1])%MOD;
}
void solve()
{
    int ans  = 0;
    for (int i = 1; i <= n; ++ i)
    {
        int curr_ans = query(1, 1, 100000, 1, a[i]) + 1;
        ///cout << a[i] << " -> " << curr_ans << endl;
        ans += curr_ans;
        ans %= MOD;
        update(1, 1, 100000, a[i], curr_ans);
    }
    cout << ans << endl;
}
int main()
{

speed();
read();
solve();
return 0;
}
/***
4
3 5 2 3

7
3 1 2 2 4 3 5

10
2 1 1 2 2 1 1 2 1 1
*/
