#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const long long MAXN = 1e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

long long n, m, v;
long long s[MAXN], special[MAXN];
bool visited[MAXN];

void read()
{
    cin >> n >> m >> v;
    long long a, b;
    for (long long i = 1; i <= m; ++ i)
    {
        cin >> a >> b;
        s[a] += b;
        visited[a] = 1;
        special[a] = b;
    }
}

long left2(long long idx)
{
    long long i = idx - 2;
    if(i < 1)
        i += n;
    return i;
}

long long right2(long long idx)
{
    long long i = idx + 2;
    if(i > n)
        i -= n;
    return i;
}

vector < long long > last, g;
long long check(long long x)
{
    memset(visited, 0, sizeof(visited));
    memset(s, 0, sizeof(s));

    queue < long long > q;
    for(long long i = 1; i <= n; ++ i)
    {
        if(special[i])
        {
            s[i] = special[i];
            visited[i] = 1;
            q.push(i);
        }
    }

    long long w ;
    long long s1, s2;

    while(!q.empty())
    {
        w = q.front();
        q.pop();

        s1 = left2(w);
        s2 = right2(w);

        if(!visited[s1])
        {
            s[s1] = x - s[w];
            visited[s1] = 1;
            q.push(s1);
        }
        else if(!special[s1] && s[s1] < x - s[w])
        {
            s[s1] = x - s[w];
            q.push(s1);
        }

        if(!visited[s2])
        {
            s[s2] = x - s[w];
            visited[s2] = 1;
            q.push(s2);
        }
        else if(!special[s2] && s[s2] < x - s[w])
        {
            s[s2] = x - s[w];
            q.push(s2);
        }
    }
    for (int i = 1; i <= n; ++ i)
    {
        if(!visited[i])
        {
            s[i] = x/2;
            visited[i] = 1;
            q.push(i);
            while(!q.empty())
            {
                w = q.front();
                q.pop();

                s1 = left2(w);
                s2 = right2(w);

                if(!visited[s1])
                {
                    s[s1] = x - s[w];
                    visited[s1] = 1;
                    q.push(s1);
                }
                else if(!special[s1] && s[s1] < x - s[w])
                {
                    s[s1] = x - s[w];
                    q.push(s1);
                }

                if(!visited[s2])
                {
                    s[s2] = x - s[w];
                    visited[s2] = 1;
                    q.push(s2);
                }
                else if(!special[s2] && s[s2] < x - s[w])
                {
                    s[s2] = x - s[w];
                    q.push(s2);
                }
            }
        }
    }
    for (long long i = 2; i < n; ++ i)
    {
        if(s[i-1] + s[i+1] < x)return false;
    }
    if(s[2] + s[n] < x)return false;
    if(s[n-1] + s[1] < x)return false;

    long long sum = 0;

    for(long long i = 1; i <= n; ++ i)
    {
        if(!special[i])
            sum += s[i];
    }
    if(sum > v)return false;
    long long ost = v - sum;
    for (int i = 1; i <= n; ++ i)
    {
       if(!special[i]) {s[i] += v - sum; break;}
    }
    last.clear();
    for (int i = 1; i <= n; ++ i)
    {
        last.push_back(s[i]);
    }
    return true;
}
void bin_search()
{
    long long l = 0, r = 1e6 * 2, mid, ans = 0;
    while(l <= r)
    {
        mid = (l + r)/2;
        //cout << mid << endl;
        if(check(mid)) /// mojem min >= mid
        {
            l = mid + 1;
            ans = mid;
            g = last;
        }
        else
            r = mid - 1;
    }
    cout << ans << endl;
    for (long long i = 0; i < n; ++ i)
        cout << g[i] << " ";
    cout << endl;
}
int main()
{

    speed();
    read();
    bin_search();
    return 0;
}
/****
5 2 16
1 3
3 7
*/
