#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 10;
const int mod = 998244353;
long long n, a[maxn], dp[maxn], b[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
    }
}

void solve12(){
    long long sum1 = 0, sum2 = 0;
    for(int i = 1;i <= n;i++){
        dp[i] = 1;
        if(a[i] == 1) dp[i] += sum1;
        else dp[i] += sum1 + sum2;
        if(a[i] == 1) sum1 += dp[i];
        else sum2 += dp[i];
        dp[i] %= mod;
        sum1 %= mod;
        sum2 %= mod;
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans += dp[i]; ans %= mod;
    }
    cout << ans << endl;
}

void solve(){
    for(int i = 1;i <= n;i++){
        dp[i] = 1;
        for(int j = 1;j < i;j++){
            if(a[i] >= a[j]) dp[i] += dp[j];
        }
        dp[i] %= mod;
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans += dp[i]; ans %= mod;
    }
    cout << ans << endl;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    speed();
    read();
    if(n > 1000) solve12();
    else{
        solve();
    }
    return 0;
}
