#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 10;
const int mod = 998244353;
long long n, check, a[maxn], dp[maxn], b[maxn], tree[4 * maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        if(a[i] > 100000) check = 1;
    }
}

void update(int i, int l, int r, int x, int val){
    if(l == r){
        tree[i] += val;
        tree[i] %= mod;
        return;
    }
    int mid = (l + r) / 2;
    if(x <= mid) update(2 * i, l, mid, x, val);
    else update(2 * i + 1, mid + 1, r, x, val);
    tree[i] = tree[2 * i] + tree[2 * i + 1];
}

long long query(int i, int l, int r, int ql, int qr){
    if(ql == l && qr == r){
        return tree[i];
    }
    int mid = (l + r) / 2;
    if(qr <= mid) return query(2 * i, l, mid, ql, qr);
    if(ql > mid) return query(2 * i + 1, mid + 1, r, ql, qr);
    return query(2 * i, l, mid, ql, mid) + query(2 * i + 1, mid + 1, r, mid + 1, qr);
}
void solve12(){
    long long sum1 = 0, sum2 = 0;
    for(int i = 1;i <= n;i++){
        dp[i] = 1;
        if(a[i] == 1) dp[i] += sum1;
        else dp[i] += sum1 + sum2;
        if(a[i] == 1) sum1 += dp[i];
        else sum2 += dp[i];
        dp[i] %= mod;
        sum1 %= mod;
        sum2 %= mod;
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans += dp[i]; ans %= mod;
    }
    cout << ans << endl;
}

void solve(){
    for(int i = 1;i <= n;i++){
        dp[i] = 1 + query(1, 1, maxn, 1, a[i]);
        dp[i] %= mod;
        update(1, 1, maxn, a[i], dp[i]);

    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans += dp[i]; ans %= mod;
    }
    cout << ans << endl;
}
void solve1(){
    for(int i = 1;i <= n;i++){
        dp[i] = 1;
        for(int j = 1;j < i;j++){
            if(a[i] >= a[j]) dp[i] += dp[j];
        }
        dp[i] %= mod;
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans += dp[i]; ans %= mod;
    }
    cout << ans << endl;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    speed();
    read();
    if(!check) solve();
    else{
        solve1();
    }
    return 0;
}
